'-----define False-----------
#ifndef FALSE
#define FALSE 0
#endif
#ifndef False
#define False 0
#endif
#ifndef false
#define false 0
#endif
'-----define True-----------
#ifndef TRUE
#define TRUE -1
#endif
#ifndef true
#define true -1
#endif
#ifndef True
#define True -1
#endif

'--declare variables --------------------------
Dim SHARED FileIn as String 
Dim SHARED FileOut as String
Dim SHARED SemiOut as String
Dim SHARED Work as String
Dim SHARED Buffer as String
Dim SHARED HlpStr as String
Dim SHARED PrgStr as String
Dim SHARED EOL as String
Dim SHARED C as String
Dim SHARED P as Integer
Dim SHARED I as Integer
Dim SHARED OverWrite as Byte
Dim SHARED AppendMode as Byte
Dim SHARED DeleteFile as Byte
Dim SHARED SplitLine as Byte
Dim SHARED AllLines as Byte
Dim SHARED Retain as Byte
Dim SHARED MarkMode as Byte
Dim SHARED Verbose as Byte
Dim SHARED DeBugMe as Byte
Dim SHARED RtnCode as Integer
Dim SHARED SemiCount as Long
Dim SHARED LineCount as Long
Dim SHARED BlankCount as Long
Dim SHARED PartialCount as Long
Dim SHARED MarkLine as Long

' set defaults ---------------------------------
PrgStr=""
EOL=chr(13) & Chr(10)
OverWrite=False
AppendMode=False
DeleteFile=False
SplitLine=False
AllLines=False
Retain=False
MarkMode=False
DeBugMe=False
Verbose=False
SemiCount=0
LineCount=0
BlankCount=0
PartialCount=0
MarkLine=0
I=0
P=0

' define Help string------------------------------
HlpStr="Syntax: StripSemicolonLines.exe file1 file2 file3 [options]" & EOL & _
       "  file1 = input filename" & EOL & _
       "  file2 = output filename" & EOL & _
       "  file3 = output filename with stripped lines (optional)" & EOL & _
       "Options:" & EOL & _
       "    /O  = Overwrite any existing output file" & EOL & _
       "    /A  = Append to any existing output file (overrides /O)" & EOL & _
       "    /D  = Delete input file" & EOL & _
       "    /R  = Retain blank lines" & EOL & _
       "    /S  = Split lines at semicolon and delete trailing portion" & EOL & _
       "    /X  = Deletes all lines with semicolon regardless of location" & EOL & _
       "    /M  = Mark end of file with " & chr(34) & ";;--PROCESSED--;;" & chr(34) & EOL & _
       "          On next run seeks to last marker before processing" & EOL & _
       "    /E  = Execute program with output file" & EOL & _
       "          Program name is delimited by a collon" & EOL & _
       "          Example /E:" & chr(34) & "full path\MyProgram.exe" & chr(34) & EOL & _
       "    /V  = Verbose prints statistics before exiting" & EOL & EOL & _
       "    /?  = display help and exit" & EOL & EOL & _
       "All lines that begin with semicolons will be removed from oputput file" & EOL & _
       "Unless /R option is used all blank lines will also be removed from oputput file" & EOL & _
       "Trailing blanks are deleted in any case" & EOL & _
       "------This program placed in the PUBLIC DOMAIN October 2013------" 

' get the command line ----------------------------------
Buffer=Command(1) 
If Buffer="/DB" then DeBugMe=True

p=1
While (Buffer<>"")
    Buffer=Trim(Ucase(Command(P))) 
    If (DeBugMe=True) then print Buffer: Sleep
    If Buffer="?"  then Print HlpStr: End: end If
    
    If len(Buffer)=2 then
        If Buffer="/?" then Print HlpStr: End: end If
        If Buffer="-?" then Print HlpStr: End: end If
        If Buffer="??" then Print HlpStr: End: end If

        If Buffer="/O" then OverWrite=True
        If Buffer="/A" then AppendMode=True
        If Buffer="/D" then DeleteFile=True
        If Buffer="/S" then SplitLine=True
        If Buffer="/X" then AllLines=True
        If Buffer="/R" then Retain=True
        If Buffer="/M" then MarkMode=True
        If Buffer="/V" then Verbose=True
    
        If Buffer="-O" then OverWrite=True
        If Buffer="-A" then AppendMode=True
        If Buffer="-D" then DeleteFile=True
        If Buffer="-S" then SplitLine=True
        If Buffer="-X" then AllLines=True
        If Buffer="-R" then Retain=True
        If Buffer="-M" then MarkMode=True
        If Buffer="-V" then Verbose=True
        
    else
        If Left(Buffer,3)= "/E:" then 
            ' allow for upper/lower case
            PrgStr=Trim(Mid(Trim(Command(P)),4))
        else 
            If Buffer="/DB" then 
                 ' do nothing
            Else ' must be a filename
                I=I+1
                If I=1 then FileIn=Trim(Command(P))
                If I=2 then FileOut=Trim(Command(P))
                If I=3 then SemiOut=Trim(Command(P))
            End If
        end If
    end If
    ' next command parameter
    P=P+1
Wend

' Appendmode overrides Overwrite mode ----------
if AppendMode=true then OverWrite=False

' debug ------
if (DeBugMe=True) then
    Print "    FileIn: " & FileIn
    Print "   FileOut: " & FileOut
    Print "   SemiOut: " & SemiOut
    Print "    PrgStr: " & PrgStr
    Print " OverWrite: " & OverWrite
    Print "AppendMode: " & AppendMode
    Print "DeleteFile: " & DeleteFile
    Print " SplitLine: " & SplitLine
    Print "  AllLines: " & AllLines
    Print "    Retain: " & Retain
    Print "  MarkMode: " & MarkMode
    Print "   Verbose: " & Verbose
    sleep
end if
    
' check file names -----------------
if (FileIn="") then Print EOL & HlpStr: End: end If
if dir(FileIn)="" then
    Print EOL & "***ERROR*** Input file not found" & EOL
    Print FileIn
    end
End If

if (FileOut="") then 
    Print EOL & "***ERROR*** No output file specified" & EOL
    End
end If

If dir(FileOut)<> "" then
    if (OverWrite=true) then
        kill (FileOut)
        RtnCode=Err
        if(RtnCode<>0) then
            Print EOL & "***ERROR*** Cannot delete existing output file"
            Print "    " & FileOut
            Print "    Error= " & RtnCode
            End
        end if
    else
        If AppendMode=false then
            Print EOL & "***ERROR*** Output file exists." 
            Print " Overwrite option not specified."
            Print " Append option not specified."
            Print "    " & FileOut 
            Print EOL & HlpStr
        End if
    end if
End If

If SemiOut<>"" then
    If dir(SemiOut)<> "" then
        if (OverWrite=true) then
            kill (SemiOut)
            RtnCode=Err
            if(RtnCode<>0) then
                Print EOL & "***ERROR*** Cannot delete existing output file"
                Print "    " & SemiOut
                Print "    Error= " & RtnCode
                End
            end if
        else
            If AppendMode=false then
                Print EOL & "***ERROR*** Output file exists." 
                Print " Overwrite option not specified."
                Print " Append option not specified."
                Print "    " & SemiOut 
                Print EOL & HlpStr
            End if
        end if
    End If
End If

' Find last mark ?? -----------
if (MarkMode=True) then 
    Open FileIn for Input as #1
    While not(eof(1))
        Line Input #1, Buffer
        LineCount=LineCount+1
        if Buffer=";;--PROCESSED--;;" then MarkLine=LineCount
    Wend
    Close #1
    LineCount=0
    If (DeBugMe=True) then print "Mark Line: " & MarkLine : Sleep
end If

' Open Files -----------------
Open FileIn for Input as #1
RtnCode=Err
If (RtnCode) <>0 then
    Print EOL & "***ERROR*** Can not open Input file."
    Print "    " & FileIn
    Print "    Error= " & RtnCode
    End
End If

Open Fileout for Append as #2
RtnCode=Err
If(RtnCode) <>0 then
    Print EOL & "***ERROR*** Can not open Output file."
    Print "    " & FileOut
    Print "    Error= " & RtnCode
    End
End If

If SemiOut<>"" then
    Open SemiOut for Append as #3
    RtnCode=Err
    If(RtnCode) <>0 then
        Print EOL & "***ERROR*** Can not open Output file."
        Print "    " & SemiOut
        Print "    Error= " & RtnCode
        End
    End If
End If
If (DeBugMe=True) then print "files opened": Sleep
'

' ---- process file -------------------
' see to last file mark
While LineCount<MarkLine
    Line Input #1, Buffer
    LineCount=LineCount+1
Wend
LineCount=0

While not (EOF(1))
    Line Input #1, Buffer
    if Trim(buffer)="" then
        BlankCount=BlankCount+1
        If (Retain=True) then Print #2,""
    Else
        C=left(trim(buffer),1)
        If C=";" then
            SemiCount=SemiCount+1
            If SemiOut<>"" then Print #3,rtrim(buffer)
        else
            P=Instr(Buffer,";")
            if (AllLines=True) and (P>0) then
                SemiCount=SemiCount+1
                If SemiOut<>"" then Print #3,rtrim(buffer)
            Else
                if (SplitLine=True) and (P>0) then
                    SemiCount=SemiCount+1
                    PartialCount=PartialCount+1
                    If SemiOut<>"" then Print #3,rtrim(buffer)
                    Buffer = Left(Buffer, P-1)
                    Print #2, rtrim(BUffer)
                Else
                    LineCount=LineCount+1
                    Print #2, rtrim(BUffer)
                end if
            end if
        end If
    end If
Wend
If (DeBugMe=True) then print "files processed": Sleep

' close files ------------------------------
close #1
close #2
If SemiOut<>"" then Close #3
if DeleteFile=True then
    kill (FileIn)
    RtnCode=Err
    if(RtnCode<>0) then
        Print EOL & "***ERROR*** Cannot delete input file"
        Print "    " & FileIn
        Print "    Error= " & RtnCode
        End
    end if
End If
If (DeBugMe=True) then print "files closed": Sleep

' Mark file as processed ------------------------
if (MarkMode=True) then 
    Open FileIn for Append as #1
    print #1, ";;--PROCESSED--;;"
    Close #1
    If (DeBugMe=True) then print "File Marked": Sleep
end If

' report -----------------------------------------
If Verbose=True then
    Print EOL & "    Total Lines: " & BlankCount+SemiCount+LineCount
    Print "Semicolon Lines: " & SemiCount
    if (SplitLine=True) and (PartialCount>0) then Print "  Partial Lines: " & PartialCount
    if (BlankCount>0) then Print "    Blank Lines: " & BlankCount
    if (SplitLine=True) then LineCount=LineCount+PartialCount
    If (Retain=True) then LineCount=LineCount+BlankCount 
    Print "   Output Lines: " & LineCount
End If

' Execute ?? --------------------------------------
If PrgStr<>"" then
    If (DeBugMe=True) then 
        print "Executing Program: " 
        print PrgStr & " " & chr(34) & Fileout & chr(34)  
        Sleep
    end if
    RtnCode=Run (PrgStr, chr(34) & Fileout & chr(34))
    If RtnCode<>0 then 
        print "***ERROR*** Execution failed:" 
        print PrgStr & " " & chr(34) & Fileout & chr(34)
    end if
end If
If (DeBugMe=True) then print "Program Complete": Sleep

' go away ------------------------------------------
end
